/******************************************************************************
 *
 * Copyright(c) 2007 - 2014 Realtek Corporation. All rights reserved.
 *
 *
 ******************************************************************************/
#ifndef __PLATFORM_STDLIB_H__
#define __PLATFORM_STDLIB_H__

#if defined(CONFIG_PLATFORM_8195A) || defined(CONFIG_PLATFORM_8711B)
#if defined (__IARSTDLIB__)
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <stdint.h>
  #include "diag.h"

  #define strsep(str, delim)      	_strsep(str, delim)
#else
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include "diag.h"
  #include "strproc.h"
  #include "basic_types.h"
  #include "hal_misc.h"
  #undef strlen
  #undef strcmp
  #undef atoi
  #undef snprintf
  #undef sprintf
  #undef printf
  #undef sscanf
  #undef strtok
  #undef strsep
  #undef strstr   
  #undef memcmp
  #undef memcpy
  #undef memset

  #define strlen(str)             	prvStrLen((const unsigned char *) str)
  #define strcmp(str1, str2)      	prvStrCmp((const unsigned char *) str1, (const unsigned char *) str2)
  #define strncmp(str1, str2, cnt)  _strncmp(str1, str2, cnt)
  #define atoi(str)               	prvAtoi(str)

#if defined (__GNUC__)
  #define snprintf                	DiagSnPrintf
#endif
  #define sprintf                 	DiagSPrintf
  #define printf                  	DiagPrintf

  #define sscanf                  	_sscanf
  #define strtok(str, delim)      	_strsep(str, delim)
  #define strsep(str, delim)      	_strsep(str, delim)
  #if defined (__GNUC__)
  #define strstr(str1, str2)      	prvStrStr(str1, str2)
  #endif
  #define strcpy(dest, src)			_strcpy(dest, src)
  #define strncpy(dest, src, count)	_strncpy(dest, src, count)
  #define strpbrk(cs, ct)			_strpbrk(cs, ct)	// for B-cut ROM
  #define strchr(s, c)				_strchr(s, c)	// for B-cut ROM
  #define memcmp(dst, src, sz)		_memcmp(dst, src, sz)
  #define memset(dst, val, sz)		_memset(dst, val, sz)
  #define memcpy(dst, src, sz)		_memcpy(dst, src, sz)
#endif

//
// memory management
//
#define malloc                  pvPortMalloc
#define free                    vPortFree

#elif defined(USE_STM322xG_EVAL) || defined(USE_STM324xG_EVAL)  || defined(STM32F10X_XL) 
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <stdint.h>
#endif


#endif //__PLATFORM_STDLIB_H__
